#define ASM
#include <vs1000.h>
#include "bookvars.h"

	.import _screen,_battery,_locked
	.import _ScreenPutData,_ScreenPutPackedX,_ScreenPutGfx
	.import _ScreenLocate


// auto void ScreenPutGfx(register __i1 const u_int16 *d,
// 		       register __c0 u_int16 words) {

	.sect code,ScreenPutGfx	// 29 words -> 16
	.export _ScreenPutGfx
_ScreenPutGfx:
//     register int i;
//     for (i=0;i<words;i++)

	stx A0,(I6)+1 ; sty A1,(I6)
	add c0,ones,c0	; ldx (I1),A1
	stx LR0,(I6)+1 ; sty LE,(I6)
	jns $0
	stx LS,(I6) ; sty LC,(I6)

	loop C0,$0-1
	ldc -8,A0

//  {
// 	ScreenPutData((s_int16)*d>>8);
// 	ScreenPutData(*d++);

	call _ScreenPutData	//A1
	ashl A1,A0,A1
	call _ScreenPutData	//A1
	ldx (I1)+1,A1/*C*/

	ldx (I1),A1/*C*/	//one instruction needed at loop end
$0:
	ldx (I6)-1,LS ; ldy (I6),LC
	ldx (I6)-1,LR0 ; ldy (I6),LE
	jr
	ldx (I6)-1,A0 ; ldy (I6),A1



// void ScreenClear(void) {

	.sect code,ScreenClear	// 29 words
	.export _ScreenClear
_ScreenClear:	// PROLOGUE
	ldx (I6)+1,NULL	// Room for Sp and Fp
	stx B1,(I6)+1 ; sty B0,(I6)
	stx LR0,(I6)+1 ; sty A1,(I6)
	stx LE,(I6)+1 ; sty LS,(I6)

//     register u_int16 i;
//     ScreenLocate(0, 0);
//     for (i=0;i<8*132;i++)
// 	ScreenPutData(0);
//     ScreenLocate(0, 0);

	call _ScreenLocate	//B0,B1
	and b,null,b	; stx LC,(I6)

	ldc 8*132-1,LS
	loop LS,$0-1
	nop

	call _ScreenPutData	//A1
	and NULL,NULL,A1

	nop
$0:
	call _ScreenLocate
	and B,NULL,B

	ldx (I6)-1,LC
	ldx (I6)-1,LE ; ldy (I6),LS
	ldx (I6)-1,LR0 ; ldy (I6),A1
	jr
	ldx (I6)-1,B1 ; ldy (I6),B0


#ifdef PARALLEL_DISPLAY
// void ScreenPutData(register __a1 u_int16 c) {

	.sect code,ScreenPutData	// 36 words
	.export _ScreenPutData
_ScreenPutData:
	ldx (I6)+1,NULL
	stx B1,(I6)+1 ; sty B0,(I6)
	stx LR0,(I6)+1 ; sty mr0,(I6)
	stx A0,(I6)+1 ; sty I0,(I6)

//   PERIP(GPIO0_CLEAR_MASK) = 0x4000;
//   NandPutAddressOctet(c ^ screen.invertMask);
//   PERIP(GPIO0_SET_MASK) = 0x4000;

	ldc 0x4000,B0
	ldc _screen+2,I0
	ldx (I0)-2,A0	; sty I1,(I6)
	ldc GPIO0_CLEAR_MASK,I1
	.import _NandPutAddressOctet	//A0
	call _NandPutAddressOctet	//A0
	xor A1,A0,A0	; STP B0,(I1)+(GPIO0_SET_MASK-GPIO0_CLEAR_MASK)/*V*/

	STP B0,(I1)/*V*/

	ldc 132,A0
	ldx (I0),B0	; ldy (I6)-1,I1
	sub B0,ONES,B0
	sub B0,A0,B1	; stx B0,(I0)+1
	ldx (I0),B1	; ldy (i6),i0
	jcc L6
	sub B1,ONES,B1	; ldx (I6)-1,A0

//   if (++screen.X >= 132) {
//     ScreenLocate(0, screen.Y+1);

	call _ScreenLocate	//B1 B0
	and NULL,NULL,B0
L6:
	ldx (I6)-1,LR0 ; ldy (I6),mr0
	jr
	ldx (I6)-1,B1 ; ldy (I6),B0
#else
// void ScreenPutData(register __a1 u_int16 c) {

	.sect code,ScreenPutData	// 36 words
	.export _ScreenPutData
_ScreenPutData:
	ldx (I6)+1,NULL
	stx B1,(I6)+1 ; sty B0,(I6)
	stx LR0,(I6)+1 ; sty mr0,(I6)
	stx A0,(I6)+1 ; sty I0,(I6)

//   PERIP(GPIO0_CLEAR_MASK) = 0x4000;
//   PERIP(GPIO1_SET_MASK)   = 0x0004; //  SCREEN_SET_DATA_MODE;
//   SpiSendReceive(c ^ screen.invertMask);
//   PERIP(GPIO0_SET_MASK) = 0x4000;

	ldc 0x4000,B0
	ldc _screen+2,I0
	ldx (I0)-2,A0	; sty I1,(I6)+1
	ldc GPIO0_CLEAR_MASK,I1
	STP B0,(I1)+(GPIO0_SET_MASK-GPIO0_CLEAR_MASK)/*V*/
	ldc GPIO1_SET_MASK,I7
	ldc 0x0004,I5
	.import _SpiSendReceive		//A0
	call _SpiSendReceive		//A0
	xor A1,A0,A0	; STP I5,(I7)/*V*/

	STP B0,(I1)/*V*/

	ldc 132,A0
	ldx (I0),B0	; ldy (I6)-1,I1
	sub B0,ONES,B0
	sub B0,A0,B1	; stx B0,(I0)+1
	ldx (I0),B1	; ldy (i6),i0
	jcc L6
	sub B1,ONES,B1	; ldx (I6)-1,A0

//   if (++screen.X >= 132) {
//     ScreenLocate(0, screen.Y+1);

	call _ScreenLocate	//B1 B0
	and NULL,NULL,B0
L6:
	ldx (I6)-1,LR0 ; ldy (I6),mr0
	jr
	ldx (I6)-1,B1 ; ldy (I6),B0
#endif


#ifdef PARALLEL_DISPLAY
// void ScreenLocate(register __b0 int x, register __b1 int y) {

	.sect code,ScreenLocate	// 34 words -> 22
	.export _ScreenLocate
_ScreenLocate:

//   PERIP(GPIO0_CLEAR_MASK) = 0x4000;
//   NandPutCommand((screen.Y = y) | 0xb0);
//   NandPutCommand((screen.X = x) & 0x0f);
//   NandPutCommand((x >> 4) | 0x0010);
//   PERIP(GPIO0_SET_MASK) = 0x4000;

	ldc GPIO0_CLEAR_MASK,I5
	ldc 0x4000,i7
	stx i7,(I5)/*V*/	; ldy (I6)+1,NULL
	stx A0,(I6) ; sty LR0,(I6)

	ldc _screen+0,I7
	stx B0,(I7)+1
	ldc 0xb0,A0
	.import _NandPutCommand
	call _NandPutCommand	//A0
	or B1,A0,A0	; stx B1,(I7)

	ldc 15,A0
	call _NandPutCommand	//A0
	and B0,A0,A0

	ldc -4,A0
	ashl B0,A0,A0
	ldc 0x10,B1
	call _NandPutCommand	//A0
	or A0,B1,A0

	ldx (I6)-1,a0	; ldy (I6),LR0
	ldc GPIO0_SET_MASK,I5
	ldc 0x4000,B0
	jr
	stx B0,(I5)/*V*/
#else
// void ScreenLocate(register __b0 int x, register __b1 int y) {

	.sect code,ScreenLocate	// 34 words -> 22
	.export _ScreenLocate
_ScreenLocate:

//   PERIP(GPIO0_CLEAR_MASK) = 0x4000;
//   PERIP(GPIO1_CLEAR_MASK) = 0x0004; //SCREEN_SET_COMMAND_MODE
//   SpiSendReceive((screen.Y = y) | 0xb0);
//   SpiSendReceive((screen.X = x) & 0x0f);
//   SpiSendReceive((x >> 4) | 0x0010);
//   PERIP(GPIO0_SET_MASK) = 0x4000;

	ldc GPIO0_CLEAR_MASK,I5
	ldc 0x4000,i7
	stx i7,(I5)/*V*/	; ldy (I6)+1,NULL
	ldc GPIO1_CLEAR_MASK,I5
	ldc 0x0004,i7
	stx i7,(I5)/*V*/
	stx A0,(I6)+1 ; sty LR0,(I6)

	ldc _screen+0,I7
	stx B0,(I7)+1
	ldc 0xb0,A0
	.import _SpiSendReceive	//A0
	call _SpiSendReceive	//A0
	or B1,A0,A0	; stx B1,(I7)

	ldc 15,A0
	call _SpiSendReceive	//A0
	and B0,A0,A0	; ldx (i6)+1,null

	ldc -4,A0
	ashl B0,A0,A0
	ldc 0x10,B1
	call _SpiSendReceive	//A0
	or A0,B1,A0	; ldx (i6)+1,null

	ldx (I6)-1,a0	; ldy (I6),LR0
	ldc GPIO0_SET_MASK,I5
	ldc 0x4000,B0
	jr
	stx B0,(I5)/*V*/
#endif	


	.end
